import java.util.* ;

class Dico {
  Dico down, next ;
  char key ;
  int val ;

  Dico (char key, Dico next) {
    this.key = key ; this.next = next ;
    val = 0 ; down = null ;
  }


  private void insertDown(String txt, int d, int val) {
    if (d >= txt.length()) {
      this.val = val ;
    } else {
      down = insert(down, txt.charAt(d), txt, d, val) ;
    }
  }

  private static Dico insert(Dico t, char x, String txt, int d, int val) {
    if (t == null) t = new Dico(x, null) ;
    char y = t.key ;
    if (x > y) {
      t.next = insert(t.next, x, txt, d, val) ;
      return t ;
    } else if (x < y) {
      t = new Dico(x, t) ;
      t.insertDown(txt, d+1, val) ;
      return t ;
    } else {
      t.insertDown(txt, d+1, val) ;
      return t ;
    }
  }

  private static Dico insert(Dico t, String txt, int val) {
    if (txt.length() == 0) throw new Error ("Insert: chane vide") ;
    return insert(t, txt.charAt(0), txt, 0, val) ;
  }

  private static Dico getCell(Dico t, String txt) {
    int len = txt.length() ;
    if (len == 0) throw new Error ("getCell: chane vide") ;
    int d = 0 ;
    char x = txt.charAt(d) ;
    while (t != null) {
      char y = t.key ;
      if (x > y) {
        t = t.next ;
      } else if (x < y) {
        return null ;
      } else {
        d++ ;
        if (d >= len) return t ;
        x = txt.charAt(d) ;
        t = t.down ;
      }
    }
    return null ;
  }

  static int get(Dico t, String txt) {
    Dico r = getCell(t, txt) ;
    if (r == null) {
      return 0 ;
    } else {
      return r.val ;
    }
  }

  static Dico put(Dico t, String txt, int val) {
    return insert(t, txt, val) ;
  }


  static private void collect
    (Dico t, StringBuilder b, List<Map.Entry<String,Integer>> list) {
    for ( ; t != null ; t = t.next) {
      b.append(t.key) ;
      if (t.val > 0) {
        final String key = b.toString() ;
        final Integer val = t.val ;
        list.add
          (new Map.Entry<String,Integer> () {
            public String getKey() { return key ; }
            public Integer getValue() { return val ; }
            public Integer setValue(Integer v)
              { throw new UnsupportedOperationException () ; }
          }) ;
      }
      collect(t.down, b, list) ;
      b.setLength(b.length()-1) ;
    }
  }

  static List<Map.Entry<String,Integer>> collect(Dico t) {
    List<Map.Entry<String,Integer>> r = 
      new LinkedList<Map.Entry<String,Integer>> () ;
    collect(t, new StringBuilder (), r) ;
    return r ;
  }
}
