import java.util.* ;

class H implements Assoc {
  private final static int SZ = 16        ; // Taille initiale 
  private final static double alpha = 4.0 ; // Charge maximale

  private int nbKeys=0 ;  // Nombre d'associations
  AList [] t ;    // Table

  H () { t = new AList[SZ] ; }

  private void resize() {
    int old_sz = t.length ;
    int new_sz = 2*old_sz  ;
    AList [] old = t ;

    System.err.println("Resize: " + old_sz + " -> " + new_sz) ;
    t = new AList [new_sz] ;
    for (int i = 0 ; i < old_sz ; i++) {
      for (AList p = old[i] ; p != null ; p = p.next) {
        int h = hash(p.key) ;
        t[h] = new AList (p.key, p.val, t[h]) ;
      }
    }
  }

  int hash(String key) { return Math.abs(key.hashCode()) % t.length ; }

  public int get(String key) {
    int h = hash(key) ;
    AList r = AList.getCell(key, t[h]) ;
    if (r == null) {
      return 0 ;
    } else {
      return r.val ;
    }
  }

  public void put(String key, int val) {
    int h = hash(key) ;
    AList r = AList.getCell(key, t[h]) ;
    if (r == null) {
      t[h] = new AList(key, val, t[h]) ;
      nbKeys++ ;
      if (t.length * alpha < nbKeys) {
        resize() ;
      }
    } else {
      r.val = val ;
    }
  }

  void collisions() {
    System.err.println("n=" + nbKeys + ", m=" + t.length + ", alpha=" +
                       ((double)nbKeys)/t.length) ; 
    HashMap<Integer, Integer> c = new HashMap<Integer, Integer> () ;    
    for (int k = 0 ; k < t.length ; k++) {
      int len = 0 ;
      for (AList p = t[k] ; p != null ; p = p.next) len++ ;
      Integer old = c.get(len) ;
      if (old == null) {
        c.put(len,1) ;
      } else {
        c.put(len, old + 1) ;
      }
    }
    for (Map.Entry<Integer,Integer> e : c.entrySet())
      System.err.println(e.getKey() + " " + e.getValue()) ;
  }

  public String toString() {
    collisions() ;
    LinkedList<Map.Entry<String,Integer>> list =
      new LinkedList<Map.Entry<String,Integer>> () ;
    for (int k = 0 ; k < t.length ; k++) {
      for (AList p = t[k] ; p != null ; p = p.next) {
        list.add(p) ;
      }
    }
    return Sort.toString(list) ;
 }
}
