import java.util.* ;

class O implements Assoc {
  private final static int SIZE = 16        ; // Taille initiale 
  static double alpha = 0.50  ; // Charge maximale

  private int nbKeys=0 ;  // Nombre d'associations
  Pair [] t ;     // Table

  O() { t = new Pair[SIZE] ; }

  private void resize() {
    int old_sz = t.length ;
    int new_sz = 2*old_sz ;
    Pair [] oldT = t ;

    System.err.println("Resize: " + old_sz + " -> " + new_sz) ;
    t = new Pair[new_sz] ;
    for (int k = 0 ; k < old_sz ; k++) {
      Pair p = oldT[k] ;
      if (p != null) {
	t[getSlot(p.key)] = p ;
      }
    }
  }

  int hash(String key) { return Math.abs(key.hashCode()) % t.length ; }

  int getSlot(String key) {
    int h0 = hash(key) ;
    int h = h0 ;
    do {
      if (t[h] == null || key.equals(t[h].key)) {
        return h ;
      }
      h++ ;
      if (h >= t.length) h = 0 ;
    } while (h != h0) ;
    throw new Error ("Table pleine") ;
  }

  public int get(String key) {
    Pair p = t[getSlot(key)] ;
    if (p == null) {
      return 0 ;
    } else {
      return p.val ;
    }
  }

  public void put(String key, int val) {
    int h = getSlot(key) ;
    Pair p = t[h] ;
    if (p == null) {
      nbKeys++ ;
      t[h] = new Pair(key, val) ;
      if (t.length * alpha < nbKeys) resize() ;
    } else {
      p.val = val ;
    }
  }

  public String toString() {
    LinkedList<Map.Entry<String,Integer>> list =
      new LinkedList<Map.Entry<String,Integer>> () ;
    for (int k = 0 ; k < t.length ; k++) {
      Pair p = t[k] ;
      if (p != null)  list.add(p) ;
    }
    return Sort.toString(list) ;
  }
}
